/*

  KOČICA FILIP
  Soutěž v PRG - kategorie mikrořadiče (25.6.2016)


  Důležité upozornění

  příkazy pro arduino do sériové linky se musí psát tímto způsobem, jak te to napsáno na papíře:

  Maxc, Minc, Maxf, Minf, Delete, Allc, Allf, Setlimitmaxc<26>    - funkční



  Pokud nebude display zobraovat hodnotu, posviťte na něj mobilem, je to nastaveno aby to nebylo příliš citlivé.


*/





#include <TM1636.h>
#include <EEPROM.h>
#include "Wire.h"
#define DS3231_I2C_ADDRESS 0x68


TM1636 tm1636(7, 8);
unsigned long cekej, cekej2;
String prijatyRetezec;

void setup() {
  Wire.begin();
  Serial.begin(9600);
  // DS3231 seconds, minutes, hours, day, date, month, year
  // setDS3231time(00,32,11,2,25,6,16);
  Serial.begin(9600);
  cekej = cekej2 = millis();
  tm1636.init();

}

void loop() {

  int hodnota = analogRead(A1);   // přečtu 8 bitovou hodnotu z R
  float r;
  r = (float)(1023 - hodnota) * 10 / hodnota; // vypočtu hodnotuR

  if ((uint16_t)r > 35) {     // pokud je lednice zavřená zhasni display
    int8_t temp[4];
    temp[0] = INDEX_BLANK;
    temp[1] = INDEX_BLANK;    // POKUD JE V UČEBNĚ TMA POSVIŤTE NA FOTOREZISTOR NAPŘ. MOBILNÉÍM TELEFONEM
    temp[2] = INDEX_BLANK;
    temp[3] = INDEX_BLANK;
    tm1636.display(temp);
  }
  else zobrazTeplotu();







  if ((uint16_t)r > 30) cekej2 = millis();  // pokud je tma (zavřená lednice), resetuj čítač !

  if (millis() > cekej2 + 30000) {      // čítač číta do 30 sekund, resetuje se řádkem nad

    if ((millis() > cekej) && (millis() < cekej + 100)) {
      analogWrite(6, 0x6d);
    }

    if ((millis() > cekej + 100) && (millis() < cekej + 200)) {     // pískání 5 Hz
      analogWrite(6, 0x00);
    }

    if (millis() > cekej + 200) cekej = millis();

  }









  char prijato;
  while (Serial.available() > 0) {    // dokud je v bufferu text
    prijato = Serial.read();
    prijatyRetezec += prijato;    // přidej ho na konec řetězce
  }
  porovnejRetezec(prijatyRetezec);    // podívej se, jestli neodpovídá nějakému příkazu

}



void porovnejRetezec(String r) {

  if (r[0] == 'M' && r[1] == 'a' && r[2] == 'x' && r[3] == 'c') {         // Maxc
    MaxCneboMinC(0, 0);
    prijatyRetezec = "";
  }

  else if (r[0] == 'M' && r[1] == 'i' && r[2] == 'n' && r[3] == 'c') {      // Minc
    MaxCneboMinC(1, 0);
    prijatyRetezec = "";
  }

  else if (r[0] == 'M' && r[1] == 'a' && r[2] == 'x' && r[3] == 'f') {      // Maxf
    MaxCneboMinC(0, 1);
    prijatyRetezec = "";
  }

  else if (r[0] == 'M' && r[1] == 'i' && r[2] == 'n' && r[3] == 'f') {      // Minf
    MaxCneboMinC(1, 1);
    prijatyRetezec = "";
  }

  else if (r[0] == 'D' && r[1] == 'e' && r[2] == 'l' && r[3] == 'e' && r[4] == 't' && r[5] == 'e') {      // Delete
    for (int i = 0; i < 255; i++) {
      EEPROM.write(i, 0);
    }                                   // smaže celou pamet
    if (EEPROM.read(0) == 0) Serial.println("OK");    // pokud je přepsaná vypíše OK
    else Serial.println("ERROR");                     // pokud ne vypíše ERROR
    prijatyRetezec = "";
  }

  else if (r[0] == 'A' && r[1] == 'l' && r[2] == 'l' && r[3] == 'c') {      // Allc
    MaxCneboMinC(0, 0);
    MaxCneboMinC(1, 0);
    prijatyRetezec = "";
  }

  else if (r[0] == 'A' && r[1] == 'l' && r[2] == 'l' && r[3] == 'f') {      // Allf
    MaxCneboMinC(0, 1);
    MaxCneboMinC(1, 1);
    prijatyRetezec = "";
  }


  else if (r[0] == 'S' && r[1] == 'e' && r[2] == 't' && r[3] == 'l' && r[4] == 'i' && r[5] == 'm' && r[6] == 'i' && r[7] == 't' && r[8] == 'm' && r[9] == 'a' && r[10] == 'x' && r[11] == 'c') {

    String b;

    for (int i = 0; i < r.length(); i++) {
      if (r[i] == '<') {
        i++;
        while (i < r.length() - 1) {
          //Serial.println(r[i]);
          b += r[i];
          i++;
        }
      }
    }

    if (b[0]) {
      prijatyRetezec = "";

      int mez;

      if (b.length() == 1) mez = b[0] - 48;
      else if (b.length() == 2) {
        mez = (10 * (b[0] - 48)) + b[1] - 48;
      }

      EEPROM.write(50, mez);      // na adresu 50 uloží maximalni teplotu nastavenou
    }
  }

  else if (r[0] == 'S' && r[1] == 'e' && r[2] == 't' && r[3] == 'l' && r[4] == 'i' && r[5] == 'm' && r[5] == 'i' && r[5] == 't' && r[5] == 'm' && r[5] == 'i' && r[5] == 'n' && r[5] == 'c') {

  }

}


void zobrazTeplotu() {


  float tep = 0;
  int odpor = 0;
  int vstup = analogRead(A0);

  odpor = (float)(1023 - vstup) * 10000 / vstup;
  int B = 3975;
  tep = 1 / (log((double)odpor / 10000) / B + 1 / 298.15) - 273.15;

  int8_t teplota = (int8_t)tep;

  int maxTeplota = EEPROM.read(50);
  if (teplota > maxTeplota) hlaseniPrekroceniTeploty(teplota);    // kontroluje překročení maximální teploty

  Serial.println(teplota);
  Serial.println(maxTeplota);

  int8_t temp[4];

  if (teplota < 0) temp[0] = INDEX_NEGATIVE_SIGN;
  else temp[0] = INDEX_BLANK;

  temp[1] = teplota / 10; // dělení deseti, zobrazí desítky
  temp[2] = teplota % 10; // bytek po celočís. dělení 10, zobrazí jednotky
  temp[3] = 12;           //zapise C
  tm1636.display(temp);



  zapisDoEEPROM(teplota);

}



void zapisDoEEPROM(uint8_t teplota) {

  byte second, minute, hour, dayOfWeek, dayOfMonth, month, year;
  readDS3231time(&second, &minute, &hour, &dayOfWeek, &dayOfMonth, &month, &year);


  int nejvyssiTeplota = EEPROM.read(0);
  int nejnizsiTeplota = EEPROM.read(1);


  if (teplota > nejvyssiTeplota) EEPROM.write(0, teplota);
  else if (teplota < nejnizsiTeplota) EEPROM.write(1, teplota);


  if ((teplota > nejvyssiTeplota) || (teplota < nejnizsiTeplota)) {

    int i = 0;
    if (teplota < nejnizsiTeplota) i += 6;
    EEPROM.write(i + 2, year);
    EEPROM.write(i + 3, month);
    EEPROM.write(i + 4, dayOfMonth);
    EEPROM.write(i + 5, hour);
    EEPROM.write(i + 6, minute);
    EEPROM.write(i + 7, second);

  }

}


void MaxCneboMinC(int nejnizsiNeboNejvyssi, bool CneboF)
{

  int teplota = EEPROM.read(nejnizsiNeboNejvyssi);   // na adrese 0 je zapsána nejvyšší teplota a na 1 je nejnižší

  int i = 0;

  if (nejnizsiNeboNejvyssi == 1) i += 6; // datumy naměření nejnižší a nejvyšší hodnoty jsou posunuty v paměti eeprom hned za sebou ( neboli o 6 )

  if (CneboF) teplota = (teplota * (9 / 5)) + 32; // přepočet na farady

  byte second, minute, hour, dayOfWeek, dayOfMonth, month, year;    // datumy naměření nejnižší a nejvyšší hodnoty jsou posunuty v paměti eeprom hned za sebou ( neboli o 6 )
  year = EEPROM.read(i + 2);
  month = EEPROM.read(i + 3);
  dayOfMonth = EEPROM.read(i + 4);
  hour = EEPROM.read(i + 5);
  minute = EEPROM.read(i + 6);
  second = EEPROM.read(i + 7);

  String vypis;

  vypis = (String)year;
  vypis += (String) + "-" + month;
  vypis += (String) + "-" + dayOfMonth;
  vypis += (String) + " " + hour;
  vypis += (String) + ":" + minute;
  vypis += (String) + ":" + second;
  vypis += (String) + " " + teplota;
  if (!CneboF) vypis += (String) + "C";
  else if (CneboF) vypis += (String) + "F";
  Serial.println(vypis);


  /*int8_t temp[4];

    if (teplota<0) temp[0] = INDEX_NEGATIVE_SIGN;
    else temp[0] = INDEX_BLANK;

    temp[1] = teplota / 10; // dělení deseti, zobrazí desítky
    temp[2] = teplota % 10; // bytek po celočís. dělení 10, zobrazí jednotky
    temp[3] = 12;           //zapise C
    tm1636.display(temp);*/


}







void hlaseniPrekroceniTeploty(int teplota) {

  unsigned long casovac1, casovac2, casovac3;
  casovac1 = casovac2 = casovac3 = millis();

  while (millis() < casovac1 + 10000) {       // čítá do 10 vteřin (smyčka se provádí 10 sekund)



    if ((millis() > casovac2) && (millis() < casovac2 + 50)) {
      for (int i = 2; i < 6; i++) digitalWrite(i, HIGH);
    }

    if ((millis() > casovac2 + 50) && (millis() < casovac2 + 100)) {     // blikání ledek 10 Hz
      for (int i = 2; i < 6; i++) digitalWrite(i, LOW);
    }

    if (millis() > casovac2 + 100) casovac2 = millis();




    if ((millis() > casovac3) && (millis() < casovac3 + 500)) {
      int8_t temp[4];

      if (teplota < 0) temp[0] = INDEX_NEGATIVE_SIGN;
      else temp[0] = INDEX_BLANK;

      temp[1] = teplota / 10; // dělení deseti, zobrazí desítky
      temp[2] = teplota % 10; // bytek po celočís. dělení 10, zobrazí jednotky
      temp[3] = 12;           //zapise C
      tm1636.display(temp);
    }

    if ((millis() > casovac3 + 500) && (millis() < casovac3 + 1000)) {     // blikání displaye 1 Hz
      int8_t temp[4];
      for (int i = 0; i < 4; i++) temp[i] = INDEX_BLANK;
      tm1636.display(temp);
    }

    if (millis() > casovac3 + 1000) casovac3 = millis();



  }

}













byte bcdToDec(byte val) {
  return ( (val / 16 * 10) + (val % 16) );
}
byte decToBcd(byte val) {
  return ( (val / 10 * 16) + (val % 10) );
}

void setDS3231time(byte second, byte minute, byte hour, byte dayOfWeek, byte dayOfMonth, byte month, byte year) {
  // sets time and date data to DS3231
  Wire.beginTransmission(DS3231_I2C_ADDRESS);
  Wire.write(0); // set next input to start at the seconds register
  Wire.write(decToBcd(second)); // set seconds
  Wire.write(decToBcd(minute)); // set minutes
  Wire.write(decToBcd(hour)); // set hours
  Wire.write(decToBcd(dayOfWeek)); // set day of week (1=Sunday, 7=Saturday)
  Wire.write(decToBcd(dayOfMonth)); // set date (1 to 31)
  Wire.write(decToBcd(month)); // set month
  Wire.write(decToBcd(year)); // set year (0 to 99)
  Wire.endTransmission();
}

void readDS3231time(byte *second, byte *minute, byte *hour, byte *dayOfWeek, byte *dayOfMonth, byte *month, byte *year) {
  Wire.beginTransmission(DS3231_I2C_ADDRESS);
  Wire.write(0); // set DS3231 register pointer to 00h
  Wire.endTransmission();
  Wire.requestFrom(DS3231_I2C_ADDRESS, 7);
  // request seven bytes of data from DS3231 starting from register 00h
  *second = bcdToDec(Wire.read() & 0x7f);
  *minute = bcdToDec(Wire.read());
  *hour = bcdToDec(Wire.read() & 0x3f);
  *dayOfWeek = bcdToDec(Wire.read());
  *dayOfMonth = bcdToDec(Wire.read());
  *month = bcdToDec(Wire.read());
  *year = bcdToDec(Wire.read());
}


